-- Test translate_amenity
set client_min_messages to warning;
create extension if not exists pgtap;
reset client_min_messages;

begin;

select plan(14);

set search_path to camper, public;

select has_function('camper', 'translate_amenity', array['integer', 'text', 'text', 'text', 'text']);
select function_lang_is('camper', 'translate_amenity', array['integer', 'text', 'text', 'text', 'text'], 'sql');
select function_returns('camper', 'translate_amenity', array['integer', 'text', 'text', 'text', 'text'], 'void');
select isnt_definer('camper', 'translate_amenity', array['integer', 'text', 'text', 'text', 'text']);
select volatility_is('camper', 'translate_amenity', array['integer', 'text', 'text', 'text', 'text'], 'volatile');
select function_privs_are('camper', 'translate_amenity', array['integer', 'text', 'text', 'text', 'text'], 'guest', array[]::text[]);
select function_privs_are('camper', 'translate_amenity', array['integer', 'text', 'text', 'text', 'text'], 'employee', array[]::text[]);
select function_privs_are('camper', 'translate_amenity', array['integer', 'text', 'text', 'text', 'text'], 'admin', array['EXECUTE']);
select function_privs_are('camper', 'translate_amenity', array['integer', 'text', 'text', 'text', 'text'], 'authenticator', array[]::text[]);


set client_min_messages to warning;
truncate amenity_i18n cascade;
truncate amenity cascade;
truncate company cascade;
reset client_min_messages;


insert into company (company_id, business_name, vatin, trade_name, phone, email, web, address, city, province, postal_code, rtc_number, tourist_tax, tourist_tax_max_days, country_code, currency_code, default_lang_tag)
values (1, 'Company 2', 'XX123', '', '555-555-555', 'a@a', '', '', '', '', '', '', 60, 7, 'ES', 'EUR', 'ca')
;

insert into amenity (amenity_id, company_id, label, name, info1, info2, active)
values (21, 1, 'A1', 'Anemity A1', '<p>Info 1</p>', '<p>Info 2</p>', true)
     , (22, 1, 'B1', 'Anemity B1', '<p>Info 1</p>', '<p>Info 2</p>', true)
;

insert into amenity_i18n (amenity_id, lang_tag, name, info1, info2)
values (22, 'ca', 'Insta A1', '<p>i1</p>', '<p>i2</p>')
     , (22, 'en', 'Anemity A1', '<p>i1</p>', '<p>i2</p>')
;

select lives_ok(
	$$ select translate_amenity(21, 'ca', '', '<p>Informació 1</p>', '') $$,
	'Should be able to translate the first type'
);

select lives_ok(
	$$ select translate_amenity(22, 'es', 'Instalación B1', '', '<p>Información 2</p>') $$,
	'Should be able to translate the second type'
);

select lives_ok(
	$$ select translate_amenity(22, 'ca', 'Instaŀlació A1', '<p>Informació 1</p>', '<p>Informació 2</p>') $$,
	'Should be able to overwrite the catalan translation of the second type'
);

select lives_ok(
	$$ select translate_amenity(22, 'en', null, null, null) $$,
	'Should be able to overwrite the english translation of the second type with all empty values'
);

select bag_eq(
	$$ select amenity_id, lang_tag, name, info1::text, info2::text from amenity_i18n $$,
	$$ values (21, 'ca', null, '<p>Informació 1</p>', null)
	        , (22, 'ca', 'Instaŀlació A1', '<p>Informació 1</p>', '<p>Informació 2</p>')
	        , (22, 'es', 'Instalación B1', null, '<p>Información 2</p>')
	        , (22, 'en', null, null, null)
	$$,
	'Should have added and updated all translations.'
);

select *
from finish();

rollback;
